//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_level1 0.85
#property indicator_level2 0.50
#property indicator_level3 0.15
#property indicator_levelcolor DimGray

//
//
//
//
//

extern double Gama1    = 0.60;
extern int    Price1   = 0;
extern int    Smooth1  = 2;
extern double Gama2    = 0.80;
extern int    Price2   = 0;
extern int    Smooth2  = 2;
extern double Gama3    = 0.50;
extern int    Price3   = 0;
extern int    Smooth3  = 0;

//
//
//
//
//

double lag1[];
double lag2[];
double lag3[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,lag1);
   SetIndexBuffer(1,lag2);
   SetIndexBuffer(2,lag3);
      IndicatorShortName("Laguerre rsi ("+DoubleToStr(Gama1,2)+","+Smooth1+")  ("+
                                          DoubleToStr(Gama2,2)+","+Smooth2+")  ("+
                                          DoubleToStr(Gama3,2)+","+Smooth3+")");
   return(0);
}

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------

int start()
{
   int    counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars - counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i = limit; i >= 0 ; i--)
   {
      lag1[i] = LaGuerre(iMA(NULL,0,1,0,MODE_SMA,Price1,i),Gama1,Smooth1,i,0);
      lag2[i] = LaGuerre(iMA(NULL,0,1,0,MODE_SMA,Price2,i),Gama2,Smooth2,i,1);
      lag3[i] = LaGuerre(iMA(NULL,0,1,0,MODE_SMA,Price3,i),Gama3,Smooth3,i,2);
   }      
   return(0);
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double workLag[][15];
double LaGuerre(double price, double gamma, int smooth, int i, int instanceNo=0)
{
   if (ArrayRange(workLag,0)!=Bars) ArrayResize(workLag,Bars); i=Bars-i-1; instanceNo*=5;

   //
   //
   //
   //
   //
      
	double CU    = 0.00;
	double CD    = 0.00;

   workLag[i][instanceNo+0] = (1.0 - gamma)*price                                          + gamma*workLag[i-1][instanceNo+0];
	workLag[i][instanceNo+1] = -gamma*workLag[i][instanceNo+0] + workLag[i-1][instanceNo+0] + gamma*workLag[i-1][instanceNo+1];
	workLag[i][instanceNo+2] = -gamma*workLag[i][instanceNo+1] + workLag[i-1][instanceNo+1] + gamma*workLag[i-1][instanceNo+2];
	workLag[i][instanceNo+3] = -gamma*workLag[i][instanceNo+2] + workLag[i-1][instanceNo+2] + gamma*workLag[i-1][instanceNo+3];

   //
   //
   //
   //
   //
   
	if (workLag[i][instanceNo+0] >= workLag[i][instanceNo+1])
   			CU = workLag[i][instanceNo+0] - workLag[i][instanceNo+1];
	else	   CD = workLag[i][instanceNo+1] - workLag[i][instanceNo+0];
	if (workLag[i][instanceNo+1] >= workLag[i][instanceNo+2])
   			CU = CU + workLag[i][instanceNo+1] - workLag[i][instanceNo+2];
	else	   CD = CD + workLag[i][instanceNo+2] - workLag[i][instanceNo+1];
	if (workLag[i][instanceNo+2] >= workLag[i][instanceNo+3])
			   CU = CU + workLag[i][instanceNo+2] - workLag[i][instanceNo+3];
	else	   CD = CD + workLag[i][instanceNo+3] - workLag[i][instanceNo+2];
   if (CU + CD != 0) 
         workLag[i][instanceNo+4] = CU / (CU + CD) ;
   else  workLag[i][instanceNo+4] = 0;

   //
   //
   //
   //
   //

   double avg=workLag[i][instanceNo+4]; for (int k=1; k<smooth; k++) avg += workLag[i-k][instanceNo+4]; avg /= MathMax(smooth,1);
   return(avg);
}

